/*
 * TemplateJDialog.java
 *
 * Created on 1 octobre 2008, 08:26
 */

package org.cocktail.sapics.client.gui;

import java.awt.BorderLayout;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.sapics.client.eof.model.EOExercice;
import org.cocktail.sapics.client.eof.model.EOVDetailAttGlobale;
import org.cocktail.sapics.client.eof.model.EOVDetailFactGlobale;
import org.cocktail.sapics.client.swing.TableSorter;
import org.cocktail.sapics.client.swing.ZEOTable;
import org.cocktail.sapics.client.swing.ZEOTableModel;
import org.cocktail.sapics.client.swing.ZEOTableModelColumn;
import org.cocktail.sapics.client.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class LotExecutionDetailView extends javax.swing.JDialog {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = -340473867575786672L;

	protected EODisplayGroup eodCommandes, eodDepenses;

	protected ZEOTable myEOTableCommandes, myEOTableDepenses;
	protected ZEOTableModel myTableModelCommandes, myTableModelDepenses ;
	protected TableSorter myTableSorterCommandes, myTableSorterDepenses;

	
    /** Creates new form TemplateJDialog */
    public LotExecutionDetailView(java.awt.Frame parent, boolean modal, EODisplayGroup dgCommandes, EODisplayGroup dgDepenses) {
    	
        super(parent, modal);
        
		eodCommandes = dgCommandes;
		eodDepenses = dgDepenses;


        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnFermer = new javax.swing.JButton();
        viewTableCommandes = new javax.swing.JPanel();
        viewTableDepenses = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        btnImprimer = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Détail Lot Exécution");
        setResizable(false);

        btnFermer.setText("Fermer");
        btnFermer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFermerActionPerformed(evt);
            }
        });

        viewTableCommandes.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableCommandes.setLayout(new java.awt.BorderLayout());

        viewTableDepenses.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableDepenses.setLayout(new java.awt.BorderLayout());

        jTextField1.setEditable(false);
        jTextField1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField1.setText("Commandes / Engagements");
        jTextField1.setFocusable(false);
        jTextField1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });

        jTextField2.setEditable(false);
        jTextField2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField2.setText("Dépenses");
        jTextField2.setFocusable(false);
        jTextField2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });

        btnImprimer.setToolTipText("Détail de l'exécution sélectionnée");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(btnImprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 46, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 566, Short.MAX_VALUE)
                        .add(btnFermer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jTextField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE)
                    .add(jTextField2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE)
                    .add(viewTableDepenses, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTableCommandes, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTableCommandes, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 143, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(30, 30, 30)
                .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTableDepenses, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 143, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(btnFermer)
                    .add(btnImprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-744)/2, (screenSize.height-450)/2, 744, 450);
    }// </editor-fold>//GEN-END:initComponents

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField2ActionPerformed

    private void btnFermerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFermerActionPerformed

        dispose();
        // TODO add your handling code here:
    }//GEN-LAST:event_btnFermerActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	AttributionView dialog = new AttributionView(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnFermer;
    private javax.swing.JButton btnImprimer;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JPanel viewTableCommandes;
    private javax.swing.JPanel viewTableDepenses;
    // End of variables declaration//GEN-END:variables
    
    
    
    
    
    
    private void initGui() {
            	
    	btnFermer.setIcon(CocktailConstantes.ICON_CLOSE);
    	btnImprimer.setIcon(CocktailConstantes.ICON_PRINTER_16);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.EXERCICE_KEY+"."+EOExercice.EXE_EXERCICE_KEY, "Année", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.CDE_LIB_KEY, "Libellé", 200);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.DATE_ENG_KEY, "Date Eng", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.AEE_ENG_HT_KEY, "Reste Engagé HT", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.AEE_LIQ_HT_KEY, "Liquidation HT", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCommandes, EOVDetailAttGlobale.AEE_EXECUTION_KEY, "Exécution HT", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelCommandes = new ZEOTableModel(eodCommandes, myCols);
		myTableSorterCommandes = new TableSorter(myTableModelCommandes);

		myEOTableCommandes = new ZEOTable(myTableSorterCommandes);
		//myEOTableNuits.addListener(myListenerContrat);
		myTableSorterCommandes.setTableHeader(myEOTableCommandes.getTableHeader());		

		myEOTableCommandes.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCommandes.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCommandes.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableCommandes.setLayout(new BorderLayout());
		viewTableCommandes.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCommandes.removeAll();
		viewTableCommandes.add(new JScrollPane(myEOTableCommandes), BorderLayout.CENTER);


    
		myCols = new Vector<ZEOTableModelColumn>();

		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.EXERCICE_KEY+"."+EOExercice.EXE_EXERCICE_KEY, "Année", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.LIBELLE_KEY, "Libellé", 200);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.DATE_EXEC_KEY, "Date Exécution", 80);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.DATE_LIQU_KEY, "Date Liquidation", 80);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.AEE_LIQ_HT_KEY, "Liquidation HT", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.AEE_EXECUTION_KEY, "Exécution HT", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.ENG_NUMERO_KEY, "Eng No", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDepenses, EOVDetailFactGlobale.ORG_UB_KEY, "UB", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelDepenses = new ZEOTableModel(eodDepenses, myCols);
		myTableSorterDepenses = new TableSorter(myTableModelDepenses);

		myEOTableDepenses = new ZEOTable(myTableSorterDepenses);
		//myEOTableNuits.addListener(myListenerContrat);
		myTableSorterDepenses.setTableHeader(myEOTableDepenses.getTableHeader());		

		myEOTableDepenses.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableDepenses.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableDepenses.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableDepenses.setLayout(new BorderLayout());
		viewTableDepenses.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableDepenses.removeAll();
		viewTableDepenses.add(new JScrollPane(myEOTableDepenses), BorderLayout.CENTER);

    }

    
    
	public javax.swing.JButton getBtnImprimer() {
		return btnImprimer;
	}

	public void setBtnImprimer(javax.swing.JButton btnImprimer) {
		this.btnImprimer = btnImprimer;
	}

	public ZEOTable getMyEOTableCommandes() {
		return myEOTableCommandes;
	}

	public void setMyEOTableCommandes(ZEOTable myEOTableCommandes) {
		this.myEOTableCommandes = myEOTableCommandes;
	}

	public ZEOTable getMyEOTableDepenses() {
		return myEOTableDepenses;
	}

	public void setMyEOTableDepenses(ZEOTable myEOTableDepenses) {
		this.myEOTableDepenses = myEOTableDepenses;
	}


}
